import structure5.*;
import java.util.Comparator;
import java.util.Random;

public class Test {
    static void testIntList() {
        int[] data = {0, 19, 10, 2, 7, 19, 20, 14, 15, 17, 8, 1, 11, 16, 4, 5, 6};

        LinkedList<Integer> list = new LinkedList<Integer>();
        for (int i = 0; i < data.length; ++i) {
            list.add(null);
        }

        for (int i = 0; i < data.length; ++i) {
            list.set(i, data[i]);
        }

        for (int i = 0; i < data.length; ++i) {
            Assert.condition(list.get(i) == data[i], "set/get test failed");
        }

        String str = list.toString();
        Assert.condition(str.equals("{0, 19, 10, 2, 7, 19, 20, 14, 15, 17, 8, 1, 11, 16, 4, 5, 6}"), 
                         "toString test failed: result = " + str);

        list.clear();
        Assert.condition(list.size() == 0, "clear test failed");
        for (int i = 0; i < data.length; ++i) {
            list.add(data[i]);
        }

        for (int i = 0; i < data.length; ++i) {
            Assert.condition(list.get(i) == data[i], "add test failed");
        }

        list.clear();
        list.addLast(0);
        list.addLast(1);
        list.addLast(2);
        Assert.condition(list.get(0) == 0, "addLast test failed");
        Assert.condition(list.get(1) == 1, "addLast test failed");
        Assert.condition(list.get(2) == 2, "addLast test failed");
        Assert.condition(list.size() == 3, "addLast test failed");

        list.clear();
        Assert.condition(list.size() == 0, "clear test failed");

        for (int i = 0; i < data.length; ++i) {
            list.add(i, data[i]);
        }

        for (int i = 0; i < data.length; ++i) {
            Assert.condition(list.get(i) == data[i], "add(i) test failed");
        }


        list.clear();
        for (int i = 0; i < data.length; ++i) {
            list.add(i, data[i]);
        }
        
        IntegerComparator c = new IntegerComparator();
        list.sort(c);
        str = list.toString();
        Assert.condition(str.equals("{0, 1, 2, 4, 5, 6, 7, 8, 10, 11, 14, 15, 16, 17, 19, 19, 20}"),
                         "Sort test failed: " + str);


        list.clear();
        list.add(0);
        list.add(1);
        java.util.Iterator<Integer> iterator = list.iterator();
        Assert.condition(iterator.hasNext(), "hasNext failed");
        Assert.condition(iterator.next() == 0, "next failed");
        Assert.condition(iterator.next() == 1, "next failed");
        Assert.condition(! iterator.hasNext(), "! hasNext failed");

        System.out.println("All LinkedList<Integer> tests passed.");
    }


    public static void main(String[] arg) {
        testIntList();
    }
}


class IntegerComparator implements Comparator<Integer> {
    public int compare(Integer a, Integer b) {
        return a.compareTo(b);
    }
    
    public boolean equals(Object obj) {
        return obj == this;
    }
}


